﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LordAshes
{
    public partial class DnD5eLinkData : ILinkData
    {
        static class Templates
        {
            public static Dictionary<string, List<string>> sections = new Dictionary<string, List<string>>();
            public static string skillRoll = "\t\t{\r\n\t\t\t\"name\": \"{Name}\",\r\n\t\t\t\"type\": \"{Type}\",\r\n\t\t\t\"roll\": \"{Roll}\"\r\n\t\t}\r\n";
            public static string attackRoll = "\t\t{\r\n\t\t\t\"name\": \"{Name}\",\r\n\t\t\t\"type\": \"{Type}\",\r\n\t\t\t\"roll\": \"{Roll}\",\r\n\t\t\t\"range\": \"{Range}\",\r\n\t\t\t\"link\":\r\n\t\t\t{\r\n\t\t\t\t\"name\": \"{DmgName}\",\r\n\t\t\t\t\"type\": \"{DmgType}\",\r\n\t\t\t\t\"roll\": \"{DmgRoll}\"\r\n\t\t\t}\r\n\t\t}\r\n";
        }

        public static string MakeAttackRoll(string name, string type, string roll, string range, string dmgName, string dmgType, string dmgRoll)
        {
            string skill = Templates.attackRoll;
            skill = skill.Replace("{Name}", name);
            skill = skill.Replace("{Type}", type);
            skill = skill.Replace("{Roll}", roll);
            skill = skill.Replace("{Range}", range);
            skill = skill.Replace("{DmgName}", dmgName);
            skill = skill.Replace("{DmgType}", dmgType);
            skill = skill.Replace("{DmgRoll}", dmgRoll);
            return skill;
        }

        public static string MakeSkillRoll(string name, string type, string roll, string note="")
        {
            string skill = Templates.skillRoll;
            if(note!="")
            {
                skill.Replace("{Roll}\"", "{Roll}\"\r\n\t\t\t\t\"link\":\r\n\t\t\t\t{\r\n\t\t\t\t\t\"name\": \""+note+"\"\r\n\t\t\t\t}");
            }
            skill = skill.Replace("{Name}", name);
            skill = skill.Replace("{Type}", type);
            skill = skill.Replace("{Roll}", roll);
            return skill;
        }
    }
}
